 %%  paper-test2 QUADRATIC n=1000
% HSL MI20 AMG PRECONDITIONER
format longe
clear
addpath('/srv/share/malc1/data/mshao/lib/hsl_mi20-1.5.1/matlab/');
javaaddpath('/srv/share/malc1/data/mshao/lib/hsl_mi20-1.5.1/matlab/');
n=1000;
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3; % number of extracted eigenpairs (k_\pm >= l_\pm)
tol=1e-7;maxiter=500;
alpha = (n+1)^1;
M=speye(n);
e = ones(n,1);
K = (n+1)^2*full(spdiags([-e 2*e -e], -1:1, n, n));
K=sparse(K);
D=2*K;
%K = spdiags([-5*e 15*e -5*e], -1:1, n, n); D = spdiags([-10*e 30*e -10*e], -1:1, n, n); % definiteness interval is around ( -9.4818, -0.5278)
% l1inearization
A=blkdiag(alpha^2*M, -K);B=[sparse(n,n) alpha*M;alpha*M D];%2n x 2n pencil
A=A/(n+1)^2; B=B/(n+1)^2;
% definiteness interval is around ( -19.225842, -0.513351)
%% initial guess
I=speye(2*n);
II=speye(n);

% exact eigenvalues
for j = 1:n,
    t = j*pi/(n+1);
    u(2*j-1:2*j) = roots([1, 4*(n+1)^2*(1-cos(t)),2*(n+1)^2*(1-cos(t))]);
end
u = sort(u');

%% 0. TEST:  mu0 (Alg.1)
mu0=-9;
T0=A-mu0*B;

hsl_mi20_startup
control0 = hsl_mi20_control;
control0.c_fail = 2;
inform0 = hsl_mi20_setup0(T0,control0);

fprintf('Test0: Algorithm 1 (one preconditioner) with AMG T = inv(A-(%f)*B) and Xini \n',mu0);
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg)/alpha;-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
tic
[D0, X, iter0,h0] = indef_lobpcg(A, B, 'hsl_mi20_precondition0', [], Xini, k_pos, k_neg, tol, maxiter);
disp([D0, abs(D0-u(n+(-k_neg+1:k_pos)))./abs(u(n+(-k_neg+1:k_pos)))]);
t0=toc;
err0=norm(A*X-B*X*diag(D0));
save('output2/outputQuadraticAMG1000.mat','h0');
save('output2/outputQuadraticAMG1000.mat','D0','-append');
save('output2/outputQuadraticAMG1000.mat','iter0','-append');
save('output2/outputQuadraticAMG1000.mat','t0','-append');
save('output2/outputQuadraticAMG1000.mat','err0','-append');

fprintf('Test0: Algorithm 1 (one preconditioner) with AMG T = inv(A-(%f)*B) and Xini \n',mu0);
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=4;k_neg=4;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg)/alpha;-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test0: Algorithm 1 (one preconditioner) with AMG T = inv(A-%f*B) and Xini_br \n',mu0);
tic
[D04, X, iter04,h04] = indef_lobpcg(A, B, 'hsl_mi20_precondition0', [], Xini, k_pos, k_neg, tol, maxiter);
disp([D04, abs(D04-u(n+(-k_neg+1:k_pos)))./abs(u(n+(-k_neg+1:k_pos)))]);
t04=toc;
err04=norm(A*X-B*X*diag(D04));
save('output2/outputQuadraticAMG1000.mat','h04','-append');
save('output2/outputQuadraticAMG1000.mat','D04','-append');
save('output2/outputQuadraticAMG1000.mat','iter04','-append');
save('output2/outputQuadraticAMG1000.mat','t04','-append');
save('output2/outputQuadraticAMG1000.mat','err04','-append');

fprintf('Test0: Algorithm 1 (one preconditioner) with AMG T = inv(A-(%f)*B) and Xini \n',mu0);
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=5;k_neg=5;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg)/alpha;-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test0: Algorithm 1 (one preconditioner) with AMG T = inv(A-%f*B) and Xini_br \n',mu0);
tic
[D05, X, iter05,h05] = indef_lobpcg(A, B, 'hsl_mi20_precondition0', [], Xini, k_pos, k_neg, tol, maxiter);
disp([D05, abs(D05-u(n+(-k_neg+1:k_pos)))./abs(u(n+(-k_neg+1:k_pos)))]);
t05=toc;
err05=norm(A*X-B*X*diag(D05));
save('output2/outputQuadraticAMG1000.mat','h05','-append');
save('output2/outputQuadraticAMG1000.mat','D05','-append');
save('output2/outputQuadraticAMG1000.mat','iter05','-append');
save('output2/outputQuadraticAMG1000.mat','t05','-append');
save('output2/outputQuadraticAMG1000.mat','err05','-append');
hsl_mi20_finalize0;




%% 1. TEST: mu1p and mu1n
mu1p=-1;
mu1n=-18.5;
T1p=A-mu1p*B;
T1n=A-mu1n*B;

hsl_mi20_startup
control1p = hsl_mi20_control;
control1p.c_fail = 2;
inform1p = hsl_mi20_setup1p(T1p,control1p);
control1n = hsl_mi20_control;
control1n.c_fail = 2;
inform1n = hsl_mi20_setup1n(T1n,control1n);

l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3; %
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg)/alpha;-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test1: Algorithm 2 (two preconditioners) with T_+ \appr inv(A-%f*B), T_-=inv(A-%f*B) and Xini \n',mu1p,mu1n);
tic
[D1, X, iter1,h1] = indef_lobpcg(A, B, 'hsl_mi20_precondition1p', 'hsl_mi20_precondition1n', Xini, k_pos, k_neg, tol, maxiter);
disp([D1, abs(D1-u(n+(-k_neg+1:k_pos)))./abs(u(n+(-k_neg+1:k_pos)))]);
t1=toc;
err1=norm(A*X-B*X*diag(D1));
save('output2/outputQuadraticAMG1000.mat','err1','-append');
save('output2/outputQuadraticAMG1000.mat','h1','-append');
save('output2/outputQuadraticAMG1000.mat','D1','-append');
save('output2/outputQuadraticAMG1000.mat','iter1','-append');
save('output2/outputQuadraticAMG1000.mat','t1','-append');


l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=4;k_neg=4; %
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg)/alpha;-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test1: Algorithm 2 (two preconditioners) with T_+  \appr inv(A-%f*B), T_-=inv(A-%f*B) and Xini_br \n',mu1p,mu1n);
tic
[D14, X, iter14,h14] = indef_lobpcg(A, B,'hsl_mi20_precondition1p', 'hsl_mi20_precondition1n', Xini, k_pos, k_neg, tol, maxiter);
disp([D14, abs(D14-u(n+(-k_neg+1:k_pos)))./abs(u(n+(-k_neg+1:k_pos)))]);
t14=toc;
err14=norm(A*X-B*X*diag(D14));
save('output2/outputQuadraticAMG1000.mat','err14','-append');
save('output2/outputQuadraticAMG1000.mat','h14','-append');
save('output2/outputQuadraticAMG1000.mat','D14','-append');
save('output2/outputQuadraticAMG1000.mat','iter14','-append');
save('output2/outputQuadraticAMG1000.mat','t14','-append');

l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=5;k_neg=5; %
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg)/alpha;-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test1: Algorithm 2 (two preconditioners) with T_+ = inv(A-%f*B), T_-=inv(A-%f*B). \n',mu1p,mu1n);
tic
[D15, X, iter15,h15] = indef_lobpcg(A, B, 'hsl_mi20_precondition1p', 'hsl_mi20_precondition1n', Xini, k_pos, k_neg, tol, maxiter);
disp([D15, abs(D15-u(n+(-k_neg+1:k_pos)))./abs(u(n+(-k_neg+1:k_pos)))]);
t15=toc;
err15=norm(A*X-B*X*diag(D15));
save('output2/outputQuadraticAMG1000.mat','err15','-append');
save('output2/outputQuadraticAMG1000.mat','h15','-append');
save('output2/outputQuadraticAMG1000.mat','D15','-append');
save('output2/outputQuadraticAMG1000.mat','iter15','-append');
save('output2/outputQuadraticAMG1000.mat','t15','-append');
hsl_mi20_finalize1p;
hsl_mi20_finalize1n;

%% 2. TEST: mu2p and mu2n
mu2p=-0.514;
mu2n=-19.22;
T2p=A-mu2p*B;
T2n=A-mu2n*B;

hsl_mi20_startup
control2p = hsl_mi20_control;
control2p.c_fail = 2;
inform2p = hsl_mi20_setup2p(T2p,control2p);
control2n = hsl_mi20_control;
control2n.c_fail = 2;
inform2n = hsl_mi20_setup2n(T2n,control2n);

k_pos=3;k_neg=3;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg)/alpha;-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ \appr inv(A-%f*B), T_-=inv(A-%f*B) and Xini \n',mu2p,mu2n);
tic
[D2, X, iter2,h2] = indef_lobpcg(A, B, 'hsl_mi20_precondition2p', 'hsl_mi20_precondition2n', Xini, k_pos, k_neg, tol, maxiter);
disp([D2, abs(D2-u(n+(-k_neg+1:k_pos)))./abs(u(n+(-k_neg+1:k_pos)))]);
t2=toc;
err2=norm(A*X-B*X*diag(D2));
save('output2/outputQuadraticAMG1000.mat','err2','-append');
save('output2/outputQuadraticAMG1000.mat','h2','-append');
save('output2/outputQuadraticAMG1000.mat','D2','-append');
save('output2/outputQuadraticAMG1000.mat','iter2','-append');
save('output2/outputQuadraticAMG1000.mat','t2','-append');

k_pos=4;k_neg=4;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg)/alpha;-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ \appr inv(A-%f*B), T_-=inv(A-%f*B) and Xini \n',mu2p,mu2n);
tic
[D24, X, iter24,h24] = indef_lobpcg(A, B,'hsl_mi20_precondition2p', 'hsl_mi20_precondition2n', Xini, k_pos, k_neg, tol, maxiter);
disp([D24, abs(D24-u(n+(-k_neg+1:k_pos)))./abs(u(n+(-k_neg+1:k_pos)))]);
t24=toc;
err24=norm(A*X-B*X*diag(D24));
save('output2/outputQuadraticAMG1000.mat','err24','-append');
save('output2/outputQuadraticAMG1000.mat','h24','-append');
save('output2/outputQuadraticAMG1000.mat','D24','-append');
save('output2/outputQuadraticAMG1000.mat','iter24','-append');
save('output2/outputQuadraticAMG1000.mat','t24','-append');

k_pos=5;k_neg=5;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg)/alpha;-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ \appr inv(A-%f*B), T_-=inv(A-%f*B) and Xini \n',mu2p,mu2n);
tic
[D25, X, iter25,h25] = indef_lobpcg(A, B,'hsl_mi20_precondition2p', 'hsl_mi20_precondition2n', Xini, k_pos, k_neg, tol, maxiter);
disp([D25, abs(D25-u(n+(-k_neg+1:k_pos)))./abs(u(n+(-k_neg+1:k_pos)))]);
t25=toc;
err25=norm(A*X-B*X*diag(D25));
save('output2/outputQuadraticAMG1000.mat','err25','-append');
save('output2/outputQuadraticAMG1000.mat','h25','-append');
save('output2/outputQuadraticAMG1000.mat','D25','-append');
save('output2/outputQuadraticAMG1000.mat','iter25','-append');
save('output2/outputQuadraticAMG1000.mat','t25','-append');


k_pos=4;k_neg=4;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg)/alpha;-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ \appr inv(A-%f*B), T_-=inv(A-%f*B) and Xini \n',mu2p,mu2n);
tic
[D243, X, iter243,h243] = indef_lobpcg(A, B, 'hsl_mi20_precondition2p', 'hsl_mi20_precondition2n', Xini, l_pos, l_neg, tol, maxiter);
t243=toc;
save('output2/outputQuadraticAMG1000.mat','h243','-append');
save('output2/outputQuadraticAMG1000.mat','D243','-append');
save('output2/outputQuadraticAMG1000.mat','iter243','-append');
save('output2/outputQuadraticAMG1000.mat','t243','-append');

hsl_mi20_finalize2p;
hsl_mi20_finalize2n;
exit;
