function [DI,X,iter0,h0,e2,DG,VG,iter0G,h0G,e2G]=plat362_example_comparison_2_crit(msch,kpos,kneg,la0,tol1,tol2)

% 25.2.2019.: comparison indef_m_scheme_brzo_inverse vs indef_m_scheme_brzoG
 %%  test_plat362 ex. 6.4
fprintf ('Testing arbitrary spectral gap using 2 versions  of the indef_m_scheme applied to the Atlantic Ocean model:\n') ;
% msch=3;kpos=2;kneg=2;la0=0.024;tol1=1e-9;tol2=1e-9;
tol=1e-7;maxiter=100;
 load plat362.mtx
 A=mmread('plat362.mtx');
n=size(A,2);
%la0=0.024;
I=speye(n);
A1=A-la0*I;B=I;
%%

tic
 [G,J,err1,err2,err3]=ind_dec(A1);
td=toc;
fprintf('\n cond(A1)=%2.5e, cond(G)=%2.5e\n', condest(A1),condest(G))


%disp(['Dekompozicija: norme gresaka = ',num2str(err)])
[err1,err2,err3]
%%
%kpos=1;kneg=1;
k=kpos+kneg;  % number of wanted eigenpairs
%msch=3;
XiniJ=InitialGuess(diag(J),kpos,kneg);
%% indef_m_scheme_brzo_inverse
Xini=G*XiniJ;
Xini=full(Xini);
fprintf('\n Test: indef_m_scheme_brzo_inverse (I, invA1) for lambda0 = %f.\n',la0);
tic
 [D, X, iter0,h0] = indef_m_scheme_brzo_inverse_2crit(I, A1, I, [], Xini, kpos, kneg, tol1, maxiter,msch);
t0=toc; 
    DI=diag(D+la0); 
    err=norm(A*X-B*X*DI);
    [norm(X(:,1)),norm(X(:,2))]
    if k==2
       disp('Norma greske reziduala po komponentama:')
       [norm(A*X(:,1)-B*X(:,1)*DI(1,1)),norm(A*X(:,2)-B*X(:,2)*DI(2,2))]
    end
  %    disp('Greska normiranja')
     e2=X'*X;
 %% indef_m_scheme_brzoG
XiniJ=full(XiniJ);
fprintf('\n Test: indef_m_scheme_brzoG for lambda0 = %f.\n',la0);
  tic
       [D0G, XG, iter0G,h0G] = indef_m_scheme_brzoG_2crit(G, J, G, [], XiniJ, kpos, kneg, tol2, maxiter,msch);
  t0G=toc;
  
     greskaAlgG=norm(G'*(G*XG)-J*XG*diag(D0G));
     VG=G*(XG/sqrt(abs(diag(D0G))));
     DG=diag(D0G+la0);   
     errG=norm(A*VG-B*VG*DG);
     if k==2
        disp('Norma greske reziduala po komponentama:')
        [norm(A*VG(:,1)-B*VG(:,1)*DG(1,1)),norm(A*VG(:,2)-B*VG(:,2)*DG(2,2))]
     end
     %err0p=norm(A*VG-B*VG*diag(DG));
     %[err0,err0p]
     % disp('Greska normiranja')
     e2G=VG'*VG;  
%% results
     for i=1:k
        [norm(X(:,i)), norm(XG(:,1)), norm(VG(:,1))]  
     end
     %
fprintf('\n cond(A1)=%2.5e, cond(G)=%2.5e\n', condest(A1),condest(G))
fprintf('\n Results: msch= %d, kpos= %d,kneg= %d.\n',msch,kpos,kneg)
fprintf('\n Test: Broj iteracija inverz= %d vs (G,J)= %d.\n',iter0,iter0G)
fprintf('\n Test: Greske inverz= %2.5e vs (G,J)=%2.5e vs nakon (G,J)= %2.5e.\n',err,greskaAlgG,errG)
fprintf('\n Test: Vrijeme inverz= %f vs (G,J)= %f.\n',t0,t0G)
norm(diag(DI)-diag(DG))
