%function []=spring_example_comparison(n,msch,kpos,kneg)
n=1000;kpos=1;kneg=1;msch=5; 
randn('state',0);
% 20.2.2019.: comparison indef_m_scheme_brzo_inverse vs indef_m_scheme_brzoG
 %%  test_spring
fprintf ('Testing arbitrary spectral gap using 2 versions  of the indef_m_scheme applied to the spring problem:\n') ;

%n=1000; 
tol=1e-7;maxiter=100;
%kpos=1;kneg=1;
%k=kpos+kneg;  % number of wanted eigenpairs

M=speye(n);
e = ones(n,1);
C = spdiags([-10*e 30*e -10*e], -1:1, n, n);
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
% definiteness interval is around ( -9.4818, -0.5278)
%% exact evs:  
%  f_neg=zeros(1,n);f_pos=zeros(1,n);
%     for k=1:n,
%         c=cos(k*pi/(n+1));
%         f([2*k-1 2*k])=roots([1, 30-20*c, 15-10*c]);
%         f([2*k-1 2*k])=sort(f([2*k-1 2*k]));
%         f_neg(n-k+1)=min(f([2*k-1 2*k]));
%         f_pos(k)=max(f([2*k-1 2*k]));
%     end
%     ev_pos=f_pos(1:kpos);               % kpos wanted B-positive evs
%     ev_neg=f_neg(n+1-kneg:n);           % kneg wanted B-negative evs
%     figure(1)
%     subplot(3,1,1)
%     plot(real(f),imag(f),'k.')
%     title('Sve svojstvene vrijednosti','FontSize',16);
%     axis([-60 10 -1 1])
%     hold all
%     subplot(3,1,2)
%     plot(f_neg,'k.')
%      title('B-negativne','FontSize',16);
%     subplot(3,1,3)
%     plot(f_pos,'k.')
%     title('B-pozitivne','FontSize',16);   
%% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M C];%2n x 2n pencil
V0=perfect_shuffling(n); %perfect shuffling
%%
lad=-5; % definitizing shift
%la0=-0.5086; % arbitrary number in (\lambda_min, \lambda_max)
la0=-30;%la0=-29.5;
%%
A1=V0'*A*V0; B1=V0'*B*V0;
A2=A1-lad*B1; % this one is positive definite
B2=B1-(1/(la0-lad))*A2;
disp('cond(B2):')
condest(B2)
tic
 [H,J,P,err]=dekompozicijaPetdijagonalne(B2);
td=toc;
%norm(H*J*H'-R)
disp(['Dekompozicija petdijagonalne: norma greske = ',num2str(err)])
L=chol(A2,'lower');
G=L\H;
% T=G'*G;
%%
kpos=5;kneg=5;msch=3;k=kpos+kneg;  % number of wanted eigenpairs
XiniJ=InitialGuess(diag(J),kpos,kneg);
%% indef_m_scheme_brzo_inverse
Xini=H*XiniJ;
Xini=full(Xini);
fprintf('\n Test: indef_m_scheme_brzo_inverse (invA2, invB2) for lambda0 = %f., lambdad=%f.\n',la0,lad);
A2=sparse(A2);
B2=sparse(B2);
tic
 [D0d, X, iter0,h0] = indef_m_scheme_brzo_inverse(A2, B2, A2, [], Xini, kpos, kneg, tol, maxiter,msch);
t0=toc; 
     V1=A2\X; % sv. vektori od (A1,B1)
     V=V0*V1; % sv. vektori od (A,B)
     d=1/(la0-lad); %broj
     D1=1./(D0d+d)+lad;
   %  disp('Norma greke reziduala:')
     err0=norm(A*V-B*V*diag(D1));
%       disp('Norma greke reziduala po komponentama:')
%      [norm(A*V(:,1)-B*V(:,1)*D1(1)),norm(A*V(:,2)-B*V(:,2)*D1(2))]
  %    disp('Greska normiranja')
     e2=V'*B*V;
%% indef_m_scheme_brzoLH
L=sparse(L);
H=sparse(H);
J=sparse(J);
XiniJ=full(XiniJ);
fprintf('\n Test0: indef_m_scheme_brzoLH ((invL G)H(invL G),J) for lambda0 = %f., lambdad=%f.\n',la0,lad);
   tic
       [D0dL, XL, iter0LH,h0L] = indef_m_scheme_brzoLH(L,H, J, G, [], XiniJ, kpos, kneg, tol, maxiter,msch);
   t0LH=toc;
     V1L=L'\(L\(H*(XL/sqrt(abs(diag(D0dL))))));
     dL=1/(la0-lad); %broj
     format long e
     % disp('Svojstvene vrijednosti izracunate algoritmom')
     D1L=1./(D0dL+dL)+lad;  
     VL=V0*V1L;
     err0L=norm(A*VL-B*VL*diag(D1L));
     if k==2
      disp('Norma greke reziduala po komponentama')
      [norm(A*VL(:,1)-B*VL(:,1)*D1L(1)),norm(A*VL(:,2)-B*VL(:,2)*D1L(2))]
     end
     % disp('Greska normiranja')
     e1L=VL'*(A-lad*B)*VL;
     e2L=VL'*B*VL; 
 %% results from comparison     
%       [iter0,iter0LH]
%       [err0,err0L]
%       [t0,t0LH]
 %% results
     for i=1:k
        [norm(X(:,i)), norm(XL(:,1)), norm(VL(:,1))]  
     end
     %
fprintf('\n cond(A1)=%2.5e, cond(G)=%2.5e\n', condest(A1),condest(G))
fprintf('\n Results: msch= %d, kpos= %d,kneg= %d.\n',msch,kpos,kneg)
fprintf('\n Test: Broj iteracija inverz= %d vs L,H= %d.\n',iter0,iter0LH)
fprintf('\n Test: Greske inverz= %2.5e vs L,H=%2.5e .\n',err0,err0L)
fprintf('\n Test: Vrijeme inverz= %f vs L,H= %f.\n',t0,t0LH)
norm(diag(D1)-diag(D1L))     
      D11=D1;D1L1=D1L;

%% drugi kriterij
%% indef_m_scheme_brzo_inverse
disp('drugi kriterij')
%% indef_m_scheme_brzo_inverse

fprintf('\n Test: indef_m_scheme_brzo_inverse (invA2, invB2) for lambda0 = %f., lambdad=%f.\n',la0,lad);
A2=sparse(A2);
B2=sparse(B2);
tic
 [D0d, X, iter02,h0] = indef_m_scheme_brzo_inverse_2crit(A2, B2, A2, [], Xini, kpos, kneg, tol, maxiter,msch);
t02=toc; 
     V1=A2\X; % sv. vektori od (A1,B1)
     V=V0*V1; % sv. vektori od (A,B)
     d=1/(la0-lad); %broj
     D1=1./(D0d+d)+lad;
   %  disp('Norma greke reziduala:')
     err02=norm(A*V-B*V*diag(D1));
%       disp('Norma greke reziduala po komponentama:')
%      [norm(A*V(:,1)-B*V(:,1)*D1(1)),norm(A*V(:,2)-B*V(:,2)*D1(2))]
  %    disp('Greska normiranja')
     e2=V'*B*V;
%% indef_m_scheme_brzoLH
fprintf('\n Test0: indef_m_scheme_brzoLH ((invL G)H(invL G),J) for lambda0 = %f., lambdad=%f.\n',la0,lad);
   tic
       [D0dL, XL, iter0LH2,h0L] = indef_m_scheme_brzoLH_2crit(L,H, J, G, [], XiniJ, kpos, kneg, tol, maxiter,msch);
   t0LH2=toc;
     V1L=L'\(L\(H*(XL/sqrt(abs(diag(D0dL))))));
     dL=1/(la0-lad); %broj
     format long e
     % disp('Svojstvene vrijednosti izracunate algoritmom')
     D1L=1./(D0dL+dL)+lad;  
     VL=V0*V1L;
     err0L2=norm(A*VL-B*VL*diag(D1L));
     if k==2
      disp('Norma greke reziduala po komponentama')
      [norm(A*VL(:,1)-B*VL(:,1)*D1L(1)),norm(A*VL(:,2)-B*VL(:,2)*D1L(2))]
     end
     % disp('Greska normiranja')
     e1L=VL'*(A-lad*B)*VL;
     e2L=VL'*B*VL; 
      disp('2. KRITERIJA: NORMA RAZLIKE SV.VRIJ.')  
     norm(diag(D1)-diag(D1L))  

 %% results from comparison     
%       [iter0,iter0LH]
%       [err0,err0L]
%       [t0,t0LH]
 %% results
%      for i=1:k
%         [norm(X(:,i)), norm(XL(:,1)), norm(VL(:,1))]  
%      end
     %
 disp('OBA KRITERIJA:')  
  disp('1. KRITERIJ:')  
 fprintf('\n cond(A1)=%2.5e, cond(G)=%2.5e\n', condest(A1),condest(G))
fprintf('\n Results: msch= %d, kpos= %d,kneg= %d.\n',msch,kpos,kneg)
fprintf('\n Test: Broj iteracija inverz= %d vs L,H= %d.\n',iter0,iter0LH)
fprintf('\n Test: Greske inverz= %2.5e vs L,H=%2.5e .\n',err0,err0L)
fprintf('\n Test: Vrijeme inverz= %f vs L,H= %f.\n',t0,t0LH)
 norm(diag(D11)-diag(D1L1)) 
 disp('2. KRITERIJ:')  
fprintf('\n Results: msch= %d, kpos= %d,kneg= %d.\n',msch,kpos,kneg)
fprintf('\n Test: Broj iteracija inverz= %d vs L,H= %d.\n',iter02,iter0LH2)
fprintf('\n Test: Greske inverz= %2.5e vs L,H=%2.5e .\n',err02,err0L2)
fprintf('\n Test: Vrijeme inverz= %f vs L,H= %f.\n',t02,t0LH2)
norm(diag(D1)-diag(D1L)) 

