randn('state',0);
 %%  test_spring
fprintf ('Testing arbitrary spectral gap using indef_m_scheme_inverse applied to the spring problem:\n') ;

n=1000; tol=1e-7;maxiter=100;
kpos=1;kneg=1;k=kpos+kneg;  % number of wanted eigenpairs

M=speye(n);
e = ones(n,1);
C = spdiags([-10*e 30*e -10*e], -1:1, n, n);
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
% definiteness interval is around ( -9.4818, -0.5278)
%% exact evs:  
 f_neg=zeros(1,n);f_pos=zeros(1,n);
    for k=1:n,
        c=cos(k*pi/(n+1));
        f([2*k-1 2*k])=roots([1, 30-20*c, 15-10*c]);
        f([2*k-1 2*k])=sort(f([2*k-1 2*k]));
        f_neg(n-k+1)=min(f([2*k-1 2*k]));
        f_pos(k)=max(f([2*k-1 2*k]));
    end
    ev_pos=f_pos(1:kpos);               % kpos wanted B-positive evs
    ev_neg=f_neg(n+1-kneg:n);           % kneg wanted B-negative evs
    figure(1)
    subplot(3,1,1)
    plot(real(f),imag(f),'k.')
    title('Sve svojstvene vrijednosti','FontSize',16);
    axis([-60 10 -1 1])
    hold all
    subplot(3,1,2)
    plot(f_neg,'k.')
     title('B-negativne','FontSize',16);
    subplot(3,1,3)
    plot(f_pos,'k.')
    title('B-pozitivne','FontSize',16);   
%% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M C];%2n x 2n pencil
V0=perfect_shuffling(n); %perfect shuffling
%%
lad=-5; % definitizing shift
la0=-0.5086; % arbitrary number in (\lambda_min, \lambda_max)
%%
A1=V0'*A*V0; B1=V0'*B*V0;
A2=A1-lad*B1; % this one is positive definite
R=B1-(1/(la0-lad))*A2;
cond(R)
tic
 [H,J,P,err]=dekompozicijaPetdijagonalne(R);
td=toc;
%norm(H*J*H'-R)
disp(['Dekompozicija petdijagonalne: norma greske = ',num2str(err)]);
L=chol(A2,'lower');

Xini=InitialGuess(diag(J),kpos,kneg);
Xini=H*Xini;
Xini=full(Xini);
fprintf('\n Test: indef_m_scheme_brzo_inverse for lambda0 = %f., lambdad=%f.\n',la0,lad);
%%
tic
 [D0d, X, iter0,h0] = indef_m_scheme_brzo_inverse(A2, R, A2, [], Xini, kpos, kneg, tol, maxiter,5);
t0=toc; 
     V1=A2\X; % sv. vektori od (A1,B1)
     V=V0*V1; % sv. vektori od (A,B)
     d=1/(la0-lad); %broj
     format long e
      disp('Svojstvene vrijednosti izracunate algoritmom')
     D1=1./(D0d+d)+lad
      disp('Svojstvene vrijednosti izracunate formulom')
     f_pos(500:503)
     disp('Norma greke reziduala:')
     err0=norm(A*V-B*V*diag(D1))
      disp('Norma greke reziduala po komponentama:')
     [norm(A*V(:,1)-B*V(:,1)*D1(1)),norm(A*V(:,2)-B*V(:,2)*D1(2))]
      disp('Greska normiranja')
     e2=V'*B*V
      disp('Vrijeme indefinitne dekompozicije, algoritma:')
     vrijeme=[td,t0]
% %  %% comparison: indef_m_scheme_brzo_inverse vs indef_m_scheme_brzo_inverse_dec3
% % tic
% %  [D0d, X, iter0,h0] = indef_m_scheme_brzo_inverse(A2, R, A2, [], Xini, kpos, kneg, tol, maxiter,5);
% % t0=toc;
% % V1=A2\X; % sv. vektori od (A1,B1)
% %      V=V0*V1; % sv. vektori od (A,B)
% %      d=1/(la0-lad); %broj
% %       D1=1./(D0d+d)+lad;
% %      disp('Norma greke reziduala:')
% %      err0=norm(A*V-B*V*diag(D1));
% %       disp('Greska normiranja')
% %      e2=V'*B*V;
% %       
% %      
% % cholA=chol(A2);
% % dA2=@(x) cholA\((cholA')\x);
% % [LB,DB]=ldl(R);
% % dR=@(x) (LB')\(DB\(LB\x));
% % tic
% %  [D0dD, XD, iter0D,h0D] = indef_m_scheme_brzo_inverse_dec3(dA2, dR, A2, [], Xini, kpos, kneg, tol, maxiter,3);
% % t0D=toc;    
% % V1D=A2\XD; % sv. vektori od (A1,B1)
% %      VD=V0*V1D; % sv. vektori od (A,B)
% %      d=1/(la0-lad); %broj
% %      D1D=1./(D0dD+d)+lad;
% %      disp('Norma greke reziduala:')
% %      err0D=norm(A*VD-B*VD*diag(D1D));
% %       disp('Greska normiranja')
% %      e2D=VD'*B*VD;
% %      
% % [iter0,iter0D]  
% % [t0,t0D]
% % [err0,err0D]
% % e2
% % e2D
% % 
% %      
% % 
% % 
% % 
