function []=comparison_indef_m_scheme_spring1()
% TEST 1: only lambda_1^+

n=200;
l_pos=1;l_neg=0; % number of wanted eigenpairs
k_pos=1;k_neg=0; % number of extracted eigenpairs (k_\pm >= l_\pm)
tol=1e-7;maxiter=500;
M=speye(n);
e = ones(n,1);
% K = (n+1)^2*full(spdiags([-e 2*e -e], -1:1, n, n));
% K=sparse(K);
% D=2*K;
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
D = spdiags([-10*e 30*e -10*e], -1:1, n, n); % definiteness interval is around ( -9.4818, -0.5278)
% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M D];%2n x 2n pencil

%% initial guess
I=speye(2*n);
II=speye(n);
%% definitizing shifts and preconditioners
mup=-0.528;
%mun=-9.47;
Tp=A-mup*B;
%Tn=A-mun*B;
% % CC = ichol(A-mup*B);
% % CholeskyIC0=@(r) CC\((CC')\r);
% % T=CholeskyIC0;

%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
X=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);

flag = [1 1 1 1 1 1];

if flag(1),
fprintf('\n Test1: Indefinite (2)-scheme  with T_+ = inv(A-(%f)*B).\n',mup);
tic
  [D2, X2, iter2,h2] = indef_m_scheme(A, B, Tp, [], X, l_pos, l_neg, tol, maxiter,2);
t2=toc;
h2.eigen_pos
D2'
fprintf('#(iterations) = %d.\n\n', iter2);
end 

if flag(2),
fprintf('\n Test1: Indefinite (3)-scheme  with T_+ = inv(A-(%f)*B).\n',mup);
tic
  [D3, X3, iter3,h3] = indef_m_scheme(A, B, Tp, [], X, l_pos, l_neg, tol, maxiter,3);
t3=toc;
D3'
fprintf('#(iterations) = %d.\n\n', iter3);
end 
if flag(3),
fprintf('\n Test1: Indefinite (4)-scheme  with T_+ = inv(A-(%f)*B).\n',mup);
tic
  [D4, X4, iter4,h4] = indef_m_scheme(A, B, Tp, [], X, l_pos, l_neg, tol, maxiter,4);
t4=toc;
D4'
fprintf('#(iterations) = %d.\n\n', iter4);
end 
if flag(4),
fprintf('\n Test1: Indefinite (5)-scheme  with T_+ = inv(A-(%f)*B).\n',mup);
tic
  [D5, X5, iter5,h5] = indef_m_scheme(A, B, Tp, [], X, l_pos, l_neg, tol, maxiter,5);
t5=toc;
D5'
fprintf('#(iterations) = %d.\n\n', iter5);
end 
if flag(5),
fprintf('\n Test1: Indefinite (6)-scheme  with T_+ = inv(A-(%f)*B).\n',mup);
tic
  [D6, X6, iter6,h6] = indef_m_scheme(A, B, Tp, [], X, l_pos, l_neg, tol, maxiter,6);
t6=toc;
D6'
fprintf('#(iterations) = %d.\n\n', iter6);
end 
if flag(6),
fprintf('\n Test1: Indefinite scheme with whole history with T_+ = inv(A-(%f)*B).\n',mup);
tic
  [Dw, Xw, iterw,hw] = indef_m_scheme(A, B, Tp, [], X, l_pos, l_neg, tol, maxiter,'whole');
tw=toc;
Dw'
fprintf('#(iterations) = %d.\n\n', iterw);
end


[def_neg,def_pos]=def_interval_spring(n);

if min(flag) == 1,
fprintf('Number of total iterations: m=2,3,4,5,6,whole')
[iter2,iter3,iter4,iter5,iter6,iterw]  
sizeh2eigpos=size(h2.eigen_pos);
figure(1);
semilogy(1:sizeh2eigpos, abs(h2.eigen_pos'-def_pos)/abs(def_pos), 'r-');
hold on;
sizeh3eigpos=size(h3.eigen_pos);
semilogy(1:sizeh3eigpos, abs(h3.eigen_pos'-def_pos)/abs(def_pos), 'b:');
sizeh4eigpos=size(h4.eigen_pos);
semilogy(1:sizeh4eigpos, abs(h4.eigen_pos'-def_pos)/abs(def_pos), 'm--o');
sizeh5eigpos=size(h5.eigen_pos);
semilogy(1:sizeh5eigpos, abs(h5.eigen_pos'-def_pos)/abs(def_pos), '-.','Color',[0,0.8,0.7]);
sizeh6eigpos=size(h6.eigen_pos);
semilogy(1:sizeh6eigpos, abs(h6.eigen_pos'-def_pos)/abs(def_pos), '--','Color',[1,0.6,0]);
sizehweigpos=size(hw.eigen_pos);
semilogy(1:sizehweigpos, abs(hw.eigen_pos'-def_pos)/abs(def_pos), ':kx');
xlabel('iteration');
ylabel('error');
title('Relative error in the smallest positive eigenvalue');
legend('m=2', 'm=3', 'm=4', 'm=5','m=6','whole');
print('-depsc2', 'test1_1.eps');
end

