hsl_mi20_startup

randn('state',0);
 %%  test_spring
 fprintf ('Testing AMG in conjunction with indef_LOBPCG applied to the spring problem:\n') ;

n=1000; kpos=2;kneg=2;k=kpos+kneg;
M=speye(n);
e = ones(n,1);
C = spdiags([-10*e 30*e -10*e], -1:1, n, n);
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
% definiteness interval is around ( -9.4818, -0.5278)

%% exact evs:  
 f_neg=zeros(1,n);f_pos=zeros(1,n);
    for k=1:n,
        c=cos(k*pi/(n+1));
        f([2*k-1 2*k])=roots([1, 30-20*c, 15-10*c]);
        f([2*k-1 2*k])=sort(f([2*k-1 2*k]));
        f_neg(n-k+1)=min(f([2*k-1 2*k]));
        f_pos(k)=max(f([2*k-1 2*k]));
    end
    ev_pos=f_pos(1:kpos);               % kpos wanted B-positive evs
    ev_neg=f_neg(n+1-kneg:n);           % kneg wanted B-negative evs
    figure(1)
    subplot(3,1,1)
    plot(real(f),imag(f),'bo')
    axis([-12 0 -1 1])
    hold all
    subplot(3,1,2)
    plot(f_neg,'g')
    subplot(3,1,3)
    plot(f_pos,'r')
    print('-depsc2', 'output/fig1.eps')

    %% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M C];%2n x 2n pencil
%beta=-.6;
%beta=-9;
beta=-5;
T=A-beta*B;
control = hsl_mi20_control;
control.c_fail = 2;
inform = hsl_mi20_setup(T,control);
%funT=@(r) (A-beta*B)\r;
I=speye(2*n);
Xini=full([I(:,n+1:n+kneg) I(:,1:kpos)]);

format short
%[D, X, iter,h] = indef_lobpcg(full(A), full(B), funT, Xini, 1e-7, 200);
[D, X, iter,h] = indef_lobpcg(A, B, 'hsl_mi20_precondition', [], Xini, kpos, kneg, 1e-7, 200);
dim=[n kneg kpos]
hsl_mi20_finalize;

m=size(h.res_neg,1);
figure(2);                                         % relative residual norm 
semilogy(5:8:m,h.res_neg(5:8:m,1), 'bo');                 % for \lambda_2^-
hold on
semilogy(7:8:m,h.res_neg(7:8:m,2), '>','Color',[0 0.7 0]); %for \lambda_1^-
semilogy(1:8:m,h.res_pos(1:8:m,1), 'rs');                  %for \lambda_1^+
semilogy(3:8:m,h.res_pos(3:8:m,2), 'c^');                  %for \lambda_2^+
semilogy(h.res_neg(1:m,1), 'b-');
semilogy(h.res_neg(1:m,2), '-','Color',[0 0.7 0]);
semilogy(h.res_pos(1:m,1), 'r-');
semilogy(h.res_pos(1:m,2), 'c-');
legend('Res(\lambda_2^-)', 'Res(\lambda_1^-)', 'Res(\lambda_1^+)', ...
        'Res(\lambda_2^+)', 'Location', 'NorthEast');
% m1 = text(20, 1e-1, 'with preconditioning');
% set(m1, 'EdgeColor', [0 0 0]);
xlabel('iteration');
title('relative residual norm');
hold on
print('-depsc2', 'output/fig2.eps')

figure(3);                                              %  relative error
semilogy(5:8:m,abs((h.eigen_neg(5:8:m,1)-ev_neg(1))./ev_neg(1)),'bo');
hold on
semilogy(7:8:m,abs((h.eigen_neg(7:8:m,2)-ev_neg(2))./ev_neg(2)),'>','Color',[0 0.7 0]);
semilogy(1:8:m,abs((h.eigen_pos(1:8:m,1)-ev_pos(1))./ev_pos(1)),'rs');
semilogy(3:8:m,abs((h.eigen_pos(3:8:m,2)-ev_pos(2))./ev_pos(2)),'c^');
semilogy(1:m,abs((h.eigen_neg(1:m,1)-ev_neg(1))./ev_neg(1)),'b-');
semilogy(1:m,abs((h.eigen_neg(1:m,2)-ev_neg(2))./ev_neg(2)),'-','Color',[0 0.7 0]);
semilogy(1:m,abs((h.eigen_pos(1:m,1)-ev_pos(1))./ev_pos(1)),'r-');
semilogy(1:m,abs((h.eigen_pos(1:m,2)-ev_pos(2))./ev_pos(2)),'c-');
legend('RelErr(\lambda_2^-)', 'RelErr(\lambda_1^-)', 'RelErr(\lambda_1^+)', ...
        'RelErr(\lambda_2^+)', 'Location', 'NorthEast');
%m1 = text(20, 1e-0, 'with preconditioning');
%set(m1, 'EdgeColor', [0 0 0]);
xlabel('iteration');
title('relative error of eigenvalues');
print('-depsc2', 'output/fig3.eps')

