load output2/outputSpring2000.mat;

 %%  test_spring

n=2000; n_pos=3;n_neg=3;k=n_pos+n_neg;
M=speye(n);
e = ones(n,1);
C = spdiags([-10*e 30*e -10*e], -1:1, n, n);
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
% definiteness interval is around ( -9.4818, -0.5278)

%% exact evs:  
 f_neg=zeros(1,n);f_pos=zeros(1,n);
    for k=1:n,
        c=cos(k*pi/(n+1));
        f([2*k-1 2*k])=roots([1, 30-20*c, 15-10*c]);
        f([2*k-1 2*k])=sort(f([2*k-1 2*k]));
        f_neg(n-k+1)=min(f([2*k-1 2*k]));
        f_pos(k)=max(f([2*k-1 2*k]));
    end
    ev_pos=f_pos(1:kpos);               % kpos wanted B-positive evs
    ev_neg=f_neg(n+1-kneg:n);           % kneg wanted B-negative evs
    figure(1)
    subplot(3,1,1)
    plot(real(f),imag(f),'bo')
    axis([-12 0 -1 1])
    hold all
    subplot(3,1,2)
    plot(f_neg,'g')
    subplot(3,1,3)
    plot(f_pos,'r')
    hold on
    %print('-depsc2', 'output/fig1.eps')
  
    %% TEST 1 %%%%%%%%%%%%%%%%
    
%%%%%%%%%%Xini%%%%%%%%%%%

m=size(evneg1,1);
m=2000;
br=100;
figure(2);                                         % relative residual norm 
semilogy(1:br:m,resneg1(1:br:m,1), 'bo');                   % for \lambda_3^-
hold on
semilogy(11:br:m,resneg1(11:br:m,2), '>','Color',[0 0.7 0]); %for \lambda_2^-
semilogy(21:br:m,resneg1(21:br:m,3), 'kx');                 %for \lambda_1^-
semilogy(1:br:m,respos1(1:br:m,1), 'r^');                  %for \lambda_1^+
semilogy(11:br:m,respos1(11:br:m,2), '*','Color',[1 0.6 0]); %for \lambda_2^+
semilogy(21:br:m,respos1(21:br:m,3), 'md');                   %for \lambda_3^+
semilogy(resneg1(1:m,1), 'b-');
semilogy(resneg1(1:m,2), '-','Color',[0 0.7 0]);
semilogy(resneg1(1:m,3), 'k-');
semilogy(respos1(1:m,1), 'r-');
semilogy(respos1(1:m,2), '-','Color',[1 0.6 0]);
semilogy(respos1(1:m,3), 'm-');
legend('Res(\lambda_3^-)','Res(\lambda_2^-)', 'Res(\lambda_1^-)', 'Res(\lambda_1^+)', ...
        'Res(\lambda_2^+)','Res(\lambda_3^+)', 'Location', 'NorthEast');
xlabel('iteration');
title('relative residual norm');
hold on
print('-depsc2', 'output/fig2.eps')

figure(3);                                              %  relative error
semilogy(1:br:m,abs((evneg1(1:br:m,1)-ev_neg(1))./ev_neg(1)),'bo');
hold on
semilogy(11:br:m,abs((evneg1(11:br:m,2)-ev_neg(2))./ev_neg(2)),'>','Color',[0 0.7 0]);
semilogy(21:br:m,abs((evneg1(21:br:m,3)-ev_neg(3))./ev_neg(3)),'kx');
semilogy(1:br:m,abs((evpos1(1:br:m,1)-ev_pos(1))./ev_pos(1)),'r^');
semilogy(11:br:m,abs((evpos1(11:br:m,2)-ev_pos(2))./ev_pos(2)),'*','Color',[1 0.6 0]);
semilogy(21:br:m,abs((evpos1(21:br:m,3)-ev_pos(3))./ev_pos(3)),'md');
semilogy(1:m,abs((evneg1(1:m,1)-ev_neg(1))./ev_neg(1)),'b-');
semilogy(1:m,abs((evneg1(1:m,2)-ev_neg(2))./ev_neg(2)),'-','Color',[0 0.7 0]);
semilogy(1:m,abs((evneg1(1:m,3)-ev_neg(3))./ev_neg(3)),'k-');
semilogy(1:m,abs((evpos1(1:m,1)-ev_pos(1))./ev_pos(1)),'r-');
semilogy(1:m,abs((evpos1(1:m,2)-ev_pos(2))./ev_pos(2)),'-','Color',[1 0.6 0]);
semilogy(1:m,abs((evpos1(1:m,3)-ev_pos(3))./ev_pos(3)),'m-');
legend('RelErr(\lambda_3^-)','RelErr(\lambda_2^-)', 'RelErr(\lambda_1^-)', 'RelErr(\lambda_1^+)', ...
        'RelErr(\lambda_2^+)','RelErr(\lambda_3^+)', 'Location', 'NorthEast');
%m1 = text(20, 1e-0, 'with preconditioning');
%set(m1, 'EdgeColor', [0 0 0]);
xlabel('iteration');
title('relative error of eigenvalues');
print('-depsc2', 'output/fig3.eps')

%%%%% Xini3 %%%%%%%%%%%
m=size(evneg13,1);
m=2000;
br=100;
figure(2);                                         % relative residual norm 
semilogy(1:br:m,resneg13(1:br:m,1), 'bo');                   % for \lambda_3^-
hold on
semilogy(11:br:m,resneg13(11:br:m,2), '>','Color',[0 0.7 0]); %for \lambda_2^-
semilogy(21:br:m,resneg13(21:br:m,3), 'kx');                 %for \lambda_1^-
semilogy(1:br:m,respos13(1:br:m,1), 'r^');                  %for \lambda_1^+
semilogy(11:br:m,respos13(11:br:m,2), '*','Color',[1 0.6 0]); %for \lambda_2^+
semilogy(21:br:m,respos13(21:br:m,3), 'md');                   %for \lambda_3^+
semilogy(resneg13(1:m,1), 'b-.');
semilogy(resneg13(1:m,2), '-.','Color',[0 0.7 0]);
semilogy(resneg13(1:m,3), 'k-.');
semilogy(respos13(1:m,1), 'r-.');
semilogy(respos13(1:m,2), '-.','Color',[1 0.6 0]);
semilogy(respos13(1:m,3), 'm-.');
legend('Res(\lambda_3^-)','Res(\lambda_2^-)', 'Res(\lambda_1^-)', 'Res(\lambda_1^+)', ...
        'Res(\lambda_2^+)','Res(\lambda_3^+)', 'Location', 'NorthEast');
xlabel('iteration');
title('relative residual norm');
hold on
print('-depsc2', 'output/fig2.eps')

figure(3);                                              %  relative error
semilogy(1:br:m,abs((evneg13(1:br:m,1)-ev_neg(1))./ev_neg(1)),'bo');
hold on
semilogy(11:br:m,abs((evneg13(11:br:m,2)-ev_neg(2))./ev_neg(2)),'>','Color',[0 0.7 0]);
semilogy(21:br:m,abs((evneg13(21:br:m,3)-ev_neg(3))./ev_neg(3)),'kx');
semilogy(1:br:m,abs((evpos13(1:br:m,1)-ev_pos(1))./ev_pos(1)),'r^');
semilogy(11:br:m,abs((evpos13(11:br:m,2)-ev_pos(2))./ev_pos(2)),'*','Color',[1 0.6 0]);
semilogy(21:br:m,abs((evpos13(21:br:m,3)-ev_pos(3))./ev_pos(3)),'md');
semilogy(1:m,abs((evneg13(1:m,1)-ev_neg(1))./ev_neg(1)),'b-.');
semilogy(1:m,abs((evneg13(1:m,2)-ev_neg(2))./ev_neg(2)),'-.','Color',[0 0.7 0]);
semilogy(1:m,abs((evneg13(1:m,3)-ev_neg(3))./ev_neg(3)),'k-.');
semilogy(1:m,abs((evpos13(1:m,1)-ev_pos(1))./ev_pos(1)),'r-.');
semilogy(1:m,abs((evpos13(1:m,2)-ev_pos(2))./ev_pos(2)),'-.','Color',[1 0.6 0]);
semilogy(1:m,abs((evpos13(1:m,3)-ev_pos(3))./ev_pos(3)),'m-.');
legend('RelErr(\lambda_3^-)','RelErr(\lambda_2^-)', 'RelErr(\lambda_1^-)', 'RelErr(\lambda_1^+)', ...
        'RelErr(\lambda_2^+)','RelErr(\lambda_3^+)', 'Location', 'NorthEast');
%m1 = text(20, 1e-0, 'with preconditioning');
%set(m1, 'EdgeColor', [0 0 0]);
xlabel('iteration');
title('relative error of eigenvalues');
print('-depsc2', 'output/fig3.eps')

%%%%% Xini6 %%%%%%%%%%%
m=size(evneg16,1);
m=2000;
br=100;
figure(2);                                         % relative residual norm 
semilogy(1:br:m,resneg16(1:br:m,1), 'bo');                   % for \lambda_3^-
hold on
semilogy(11:br:m,resneg16(11:br:m,2), '>','Color',[0 0.7 0]); %for \lambda_2^-
semilogy(21:br:m,resneg16(21:br:m,3), 'kx');                 %for \lambda_1^-
semilogy(1:br:m,respos16(1:br:m,1), 'r^');                  %for \lambda_1^+
semilogy(11:br:m,respos16(11:br:m,2), '*','Color',[1 0.6 0]); %for \lambda_2^+
semilogy(21:br:m,respos16(21:br:m,3), 'md');                   %for \lambda_3^+
semilogy(resneg16(1:m,1), 'b--');
semilogy(resneg16(1:m,2), '--','Color',[0 0.7 0]);
semilogy(resneg16(1:m,3), 'k--');
semilogy(respos16(1:m,1), 'r--');
semilogy(respos16(1:m,2), '--','Color',[1 0.6 0]);
semilogy(respos16(1:m,3), 'm--');
legend('Res(\lambda_3^-)','Res(\lambda_2^-)', 'Res(\lambda_1^-)', 'Res(\lambda_1^+)', ...
        'Res(\lambda_2^+)','Res(\lambda_3^+)', 'Location', 'NorthEast');
xlabel('iteration');
title('relative residual norm');
hold on
print('-depsc2', 'output/fig2.eps')

figure(3);                                              %  relative error
semilogy(1:br:m,abs((evneg16(1:br:m,1)-ev_neg(1))./ev_neg(1)),'bo');
hold on
semilogy(11:br:m,abs((evneg16(11:br:m,2)-ev_neg(2))./ev_neg(2)),'>','Color',[0 0.7 0]);
semilogy(21:br:m,abs((evneg16(21:br:m,3)-ev_neg(3))./ev_neg(3)),'kx');
semilogy(1:br:m,abs((evpos16(1:br:m,1)-ev_pos(1))./ev_pos(1)),'r^');
semilogy(11:br:m,abs((evpos16(11:br:m,2)-ev_pos(2))./ev_pos(2)),'*','Color',[1 0.6 0]);
semilogy(21:br:m,abs((evpos16(21:br:m,3)-ev_pos(3))./ev_pos(3)),'md');
semilogy(1:m,abs((evneg16(1:m,1)-ev_neg(1))./ev_neg(1)),'b--');
semilogy(1:m,abs((evneg16(1:m,2)-ev_neg(2))./ev_neg(2)),'--','Color',[0 0.7 0]);
semilogy(1:m,abs((evneg16(1:m,3)-ev_neg(3))./ev_neg(3)),'k--');
semilogy(1:m,abs((evpos16(1:m,1)-ev_pos(1))./ev_pos(1)),'r--');
semilogy(1:m,abs((evpos16(1:m,2)-ev_pos(2))./ev_pos(2)),'--','Color',[1 0.6 0]);
semilogy(1:m,abs((evpos16(1:m,3)-ev_pos(3))./ev_pos(3)),'m--');
legend('RelErr(\lambda_3^-)','RelErr(\lambda_2^-)', 'RelErr(\lambda_1^-)', 'RelErr(\lambda_1^+)', ...
        'RelErr(\lambda_2^+)','RelErr(\lambda_3^+)', 'Location', 'NorthEast');
%m1 = text(20, 1e-0, 'with preconditioning');
%set(m1, 'EdgeColor', [0 0 0]);
xlabel('iteration');
title('relative error of eigenvalues');
print('-depsc2', 'output/fig3.eps')



