%% TEST 2  2000 vs 1000 %%%%%%%%%%%%%%%%
 
 load output/outputSpring2000.mat;
 
  %%  test_spring

n=2000; n_pos=3;n_neg=3;k=n_pos+n_neg;
M=speye(n);
e = ones(n,1);
C = spdiags([-10*e 30*e -10*e], -1:1, n, n);
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
% definiteness interval is around ( -9.4818, -0.5278)

%% exact evs:  
 f_neg=zeros(1,n);f_pos=zeros(1,n);
    for k=1:n,
        c=cos(k*pi/(n+1));
        f([2*k-1 2*k])=roots([1, 30-20*c, 15-10*c]);
        f([2*k-1 2*k])=sort(f([2*k-1 2*k]));
        f_neg(n-k+1)=min(f([2*k-1 2*k]));
        f_pos(k)=max(f([2*k-1 2*k]));
    end
    ev_pos=f_pos(1:n_pos);               % n_pos wanted B-positive evs
    ev_neg=f_neg(n+1-n_neg:n);           % n_neg wanted B-negative evs
    figure(1)
    subplot(3,1,1)
    plot(real(f),imag(f),'bo')
    title('eigenvalues');
    axis([-50 0 -1 1])
    hold all
    subplot(3,1,2)
    plot(f_neg,'kx')
    title('B-negative eigenvalues');
    hold on
    subplot(3,1,3)
    plot(f_pos,'rx')
    title('B-positive eigenvalues');
    hold on
%%%%%%%%%%Xini%%%%%%%%%%%

m=size(evneg2,1);m=1300;
br=100;
figure(4);                                         % relative residual norm 
semilogy(1:br:m,resneg2(1:br:m,1), 'bo');                   % for \lambda_3^-
hold on
semilogy(11:br:m,resneg2(11:br:m,2), '>','Color',[0 0.7 0]); %for \lambda_2^-
semilogy(21:br:m,resneg2(21:br:m,3), 'kx');                 %for \lambda_1^-
semilogy(1:br:m,respos2(1:br:m,1), 'r^');                  %for \lambda_1^+
semilogy(11:br:m,respos2(11:br:m,2), '*','Color',[1 0.6 0]); %for \lambda_2^+
semilogy(21:br:m,respos2(21:br:m,3), 'md');                   %for \lambda_3^+
semilogy(resneg2(1:m,1), 'b-');
semilogy(resneg2(1:m,2), '-','Color',[0 0.7 0]);
semilogy(resneg2(1:m,3), 'k-');
semilogy(respos2(1:m,1), 'r-');
semilogy(respos2(1:m,2), '-','Color',[1 0.6 0]);
semilogy(respos2(1:m,3), 'm-');
legend('Res(\lambda_3^-)','Res(\lambda_2^-)', 'Res(\lambda_1^-)', 'Res(\lambda_1^+)', ...
        'Res(\lambda_2^+)','Res(\lambda_3^+)', 'Location', 'NorthEast');
xlabel('iteration');
title('relative residual norm');
hold on


figure(5);                                              %  relative error
semilogy(1:br:m,abs((evneg2(1:br:m,1)-ev_neg(1))./ev_neg(1)),'bo');
hold on
semilogy(11:br:m,abs((evneg2(11:br:m,2)-ev_neg(2))./ev_neg(2)),'>','Color',[0 0.7 0]);
semilogy(21:br:m,abs((evneg2(21:br:m,3)-ev_neg(3))./ev_neg(3)),'kx');
semilogy(1:br:m,abs((evpos2(1:br:m,1)-ev_pos(1))./ev_pos(1)),'r^');
semilogy(11:br:m,abs((evpos2(11:br:m,2)-ev_pos(2))./ev_pos(2)),'*','Color',[1 0.6 0]);
semilogy(21:br:m,abs((evpos2(21:br:m,3)-ev_pos(3))./ev_pos(3)),'md');
semilogy(1:m,abs((evneg2(1:m,1)-ev_neg(1))./ev_neg(1)),'b-');
semilogy(1:m,abs((evneg2(1:m,2)-ev_neg(2))./ev_neg(2)),'-','Color',[0 0.7 0]);
semilogy(1:m,abs((evneg2(1:m,3)-ev_neg(3))./ev_neg(3)),'k-');
semilogy(1:m,abs((evpos2(1:m,1)-ev_pos(1))./ev_pos(1)),'r-');
semilogy(1:m,abs((evpos2(1:m,2)-ev_pos(2))./ev_pos(2)),'-','Color',[1 0.6 0]);
semilogy(1:m,abs((evpos2(1:m,3)-ev_pos(3))./ev_pos(3)),'m-');
legend('RelErr(\lambda_3^-)','RelErr(\lambda_2^-)', 'RelErr(\lambda_1^-)', 'RelErr(\lambda_1^+)', ...
        'RelErr(\lambda_2^+)','RelErr(\lambda_3^+)', 'Location', 'NorthEast');
%m1 = text(20, 1e-0, 'with preconditioning');
%set(m1, 'EdgeColor', [0 0 0]);
xlabel('iteration');
title('relative error of eigenvalues');


%%%%%%%%%%%%
 %% TEST 3 %%%%%%%%%%%%%%%%

 load output/outputSpring1000.mat;
   %%  test_spring

n=1000; n_pos=3;n_neg=3;k=n_pos+n_neg;
M=speye(n);
e = ones(n,1);
C = spdiags([-10*e 30*e -10*e], -1:1, n, n);
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
% definiteness interval is around ( -9.4818, -0.5278)

%% exact evs:  
 f_neg=zeros(1,n);f_pos=zeros(1,n);
    for k=1:n,
        c=cos(k*pi/(n+1));
        f([2*k-1 2*k])=roots([1, 30-20*c, 15-10*c]);
        f([2*k-1 2*k])=sort(f([2*k-1 2*k]));
        f_neg(n-k+1)=min(f([2*k-1 2*k]));
        f_pos(k)=max(f([2*k-1 2*k]));
    end
    ev_pos=f_pos(1:n_pos);               % n_pos wanted B-positive evs
    ev_neg=f_neg(n+1-n_neg:n);           % n_neg wanted B-negative evs
    figure(1)
    subplot(3,1,1)
    plot(real(f),imag(f),'cx')
    axis([-50 0 -1 1])
    hold all
    subplot(3,1,2)
    plot(f_neg,'x','Color',[0 0.7 0])
    hold on
    subplot(3,1,3)
    plot(f_pos,'mx')
%%%%%%%%%%Xini%%%%%%%%%%%

m=size(evneg2,1);
m=1300;
br=100;
figure(4);                                         % relative residual norm 
semilogy(1:br:m,resneg2(1:br:m,1), 'bo');                   % for \lambda_3^-
hold on
semilogy(11:br:m,resneg2(11:br:m,2), '>','Color',[0 0.7 0]); %for \lambda_2^-
semilogy(21:br:m,resneg2(21:br:m,3), 'kx');                 %for \lambda_1^-
semilogy(1:br:m,respos2(1:br:m,1), 'r^');                  %for \lambda_1^+
semilogy(11:br:m,respos2(11:br:m,2), '*','Color',[1 0.6 0]); %for \lambda_2^+
semilogy(21:br:m,respos2(21:br:m,3), 'md');                   %for \lambda_3^+
semilogy(resneg2(1:m,1), 'b-.');
semilogy(resneg2(1:m,2), '-.','Color',[0 0.7 0]);
semilogy(resneg2(1:m,3), 'k-.');
semilogy(respos2(1:m,1), 'r-.');
semilogy(respos2(1:m,2), '-.','Color',[1 0.6 0]);
semilogy(respos2(1:m,3), 'm-.');
legend('Res(\lambda_3^-)','Res(\lambda_2^-)', 'Res(\lambda_1^-)', 'Res(\lambda_1^+)', ...
        'Res(\lambda_2^+)','Res(\lambda_3^+)', 'Location', 'NorthEast');
xlabel('iteration');
title('relative residual norm: \beta_1= -7.5, \beta_2= -2.5');
hold on
print('-depsc2', 'output/spring2_relres.eps')
print('-depsc2', 'output/sprig2_relres.fig')

figure(5);                                              %  relative error
semilogy(1:br:m,abs((evneg2(1:br:m,1)-ev_neg(1))./ev_neg(1)),'bo');
hold on
semilogy(11:br:m,abs((evneg2(11:br:m,2)-ev_neg(2))./ev_neg(2)),'>','Color',[0 0.7 0]);
semilogy(21:br:m,abs((evneg2(21:br:m,3)-ev_neg(3))./ev_neg(3)),'kx');
semilogy(1:br:m,abs((evpos2(1:br:m,1)-ev_pos(1))./ev_pos(1)),'r^');
semilogy(11:br:m,abs((evpos2(11:br:m,2)-ev_pos(2))./ev_pos(2)),'*','Color',[1 0.6 0]);
semilogy(21:br:m,abs((evpos2(21:br:m,3)-ev_pos(3))./ev_pos(3)),'md');
semilogy(1:m,abs((evneg2(1:m,1)-ev_neg(1))./ev_neg(1)),'b-.');
semilogy(1:m,abs((evneg2(1:m,2)-ev_neg(2))./ev_neg(2)),'-.','Color',[0 0.7 0]);
semilogy(1:m,abs((evneg2(1:m,3)-ev_neg(3))./ev_neg(3)),'k-.');
semilogy(1:m,abs((evpos2(1:m,1)-ev_pos(1))./ev_pos(1)),'r-.');
semilogy(1:m,abs((evpos2(1:m,2)-ev_pos(2))./ev_pos(2)),'-.','Color',[1 0.6 0]);
semilogy(1:m,abs((evpos2(1:m,3)-ev_pos(3))./ev_pos(3)),'m-.');
legend('RelErr(\lambda_3^-)','RelErr(\lambda_2^-)', 'RelErr(\lambda_1^-)', 'RelErr(\lambda_1^+)', ...
        'RelErr(\lambda_2^+)','RelErr(\lambda_3^+)', 'Location', 'NorthEast');
%m1 = text(20, 1e-0, 'with preconditioning');
%set(m1, 'EdgeColor', [0 0 0]);
xlabel('iteration');
title('relative error of eigenvalues:  \beta_1= -7.5, \beta_2= -2.5');
print('-depsc2', 'output/spring2_relerr.eps')
print('-depsc2', 'output/spring2_relerr.fig')

% %%%%% Xini3 %%%%%%%%%%%
% m=size(evneg23,1);
% m=2000;
% br=100;
% figure(4);                                         % relative residual norm 
% semilogy(1:br:m,resneg23(1:br:m,1), 'bo');                   % for \lambda_3^-
% hold on
% semilogy(11:br:m,resneg23(11:br:m,2), '>','Color',[0 0.7 0]); %for \lambda_2^-
% semilogy(21:br:m,resneg23(21:br:m,3), 'kx');                 %for \lambda_1^-
% semilogy(1:br:m,respos23(1:br:m,1), 'r^');                  %for \lambda_1^+
% semilogy(11:br:m,respos23(11:br:m,2), '*','Color',[1 0.6 0]); %for \lambda_2^+
% semilogy(21:br:m,respos23(21:br:m,3), 'md');                   %for \lambda_3^+
% semilogy(resneg23(1:m,1), 'b-.');
% semilogy(resneg23(1:m,2), '-.','Color',[0 0.7 0]);
% semilogy(resneg23(1:m,3), 'k-.');
% semilogy(respos23(1:m,1), 'r-.');
% semilogy(respos23(1:m,2), '-.','Color',[1 0.6 0]);
% semilogy(respos23(1:m,3), 'm-.');
% legend('Res(\lambda_3^-)','Res(\lambda_2^-)', 'Res(\lambda_1^-)', 'Res(\lambda_1^+)', ...
%         'Res(\lambda_2^+)','Res(\lambda_3^+)', 'Location', 'NorthEast');
% xlabel('iteration');
% title('relative residual norm');
% hold on
% print('-depsc2', 'output/fig2.eps')
% 
% figure(5);                                              %  relative error
% semilogy(1:br:m,abs((evneg23(1:br:m,1)-ev_neg(1))./ev_neg(1)),'bo');
% hold on
% semilogy(11:br:m,abs((evneg23(11:br:m,2)-ev_neg(2))./ev_neg(2)),'>','Color',[0 0.7 0]);
% semilogy(21:br:m,abs((evneg23(21:br:m,3)-ev_neg(3))./ev_neg(3)),'kx');
% semilogy(1:br:m,abs((evpos23(1:br:m,1)-ev_pos(1))./ev_pos(1)),'r^');
% semilogy(11:br:m,abs((evpos23(11:br:m,2)-ev_pos(2))./ev_pos(2)),'*','Color',[1 0.6 0]);
% semilogy(21:br:m,abs((evpos23(21:br:m,3)-ev_pos(3))./ev_pos(3)),'md');
% semilogy(1:m,abs((evneg23(1:m,1)-ev_neg(1))./ev_neg(1)),'b-.');
% semilogy(1:m,abs((evneg23(1:m,2)-ev_neg(2))./ev_neg(2)),'-.','Color',[0 0.7 0]);
% semilogy(1:m,abs((evneg23(1:m,3)-ev_neg(3))./ev_neg(3)),'k-.');
% semilogy(1:m,abs((evpos23(1:m,1)-ev_pos(1))./ev_pos(1)),'r-.');
% semilogy(1:m,abs((evpos23(1:m,2)-ev_pos(2))./ev_pos(2)),'-.','Color',[1 0.6 0]);
% semilogy(1:m,abs((evpos23(1:m,3)-ev_pos(3))./ev_pos(3)),'m-.');
% legend('RelErr(\lambda_3^-)','RelErr(\lambda_2^-)', 'RelErr(\lambda_1^-)', 'RelErr(\lambda_1^+)', ...
%         'RelErr(\lambda_2^+)','RelErr(\lambda_3^+)', 'Location', 'NorthEast');
% %m1 = text(20, 1e-0, 'with preconditioning');
% %set(m1, 'EdgeColor', [0 0 0]);
% xlabel('iteration');
% title('relative error of eigenvalues');
% print('-depsc2', 'output/fig3.eps')
% 
% %%%%% Xini6 %%%%%%%%%%%
% m=size(evneg26,1);
% m=2000;
% br=100;
% figure(4);                                         % relative residual norm 
% semilogy(1:br:m,resneg26(1:br:m,1), 'bo');                   % for \lambda_3^-
% hold on
% semilogy(11:br:m,resneg26(11:br:m,2), '>','Color',[0 0.7 0]); %for \lambda_2^-
% semilogy(21:br:m,resneg26(21:br:m,3), 'kx');                 %for \lambda_1^-
% semilogy(1:br:m,respos26(1:br:m,1), 'r^');                  %for \lambda_1^+
% semilogy(11:br:m,respos26(11:br:m,2), '*','Color',[1 0.6 0]); %for \lambda_2^+
% semilogy(21:br:m,respos26(21:br:m,3), 'md');                   %for \lambda_3^+
% semilogy(resneg26(1:m,1), 'b--');
% semilogy(resneg26(1:m,2), '--','Color',[0 0.7 0]);
% semilogy(resneg26(1:m,3), 'k--');
% semilogy(respos26(1:m,1), 'r--');
% semilogy(respos26(1:m,2), '--','Color',[1 0.6 0]);
% semilogy(respos26(1:m,3), 'm--');
% legend('Res(\lambda_3^-)','Res(\lambda_2^-)', 'Res(\lambda_1^-)', 'Res(\lambda_1^+)', ...
%         'Res(\lambda_2^+)','Res(\lambda_3^+)', 'Location', 'NorthEast');
% xlabel('iteration');
% title('relative residual norm');
% hold on
% print('-depsc2', 'output/fig2.eps')
% 
% figure(5);                                              %  relative error
% semilogy(1:br:m,abs((evneg26(1:br:m,1)-ev_neg(1))./ev_neg(1)),'bo');
% hold on
% semilogy(11:br:m,abs((evneg26(11:br:m,2)-ev_neg(2))./ev_neg(2)),'>','Color',[0 0.7 0]);
% semilogy(21:br:m,abs((evneg26(21:br:m,3)-ev_neg(3))./ev_neg(3)),'kx');
% semilogy(1:br:m,abs((evpos26(1:br:m,1)-ev_pos(1))./ev_pos(1)),'r^');
% semilogy(11:br:m,abs((evpos26(11:br:m,2)-ev_pos(2))./ev_pos(2)),'*','Color',[1 0.6 0]);
% semilogy(21:br:m,abs((evpos26(21:br:m,3)-ev_pos(3))./ev_pos(3)),'md');
% semilogy(1:m,abs((evneg26(1:m,1)-ev_neg(1))./ev_neg(1)),'b--');
% semilogy(1:m,abs((evneg26(1:m,2)-ev_neg(2))./ev_neg(2)),'--','Color',[0 0.7 0]);
% semilogy(1:m,abs((evneg26(1:m,3)-ev_neg(3))./ev_neg(3)),'k--');
% semilogy(1:m,abs((evpos26(1:m,1)-ev_pos(1))./ev_pos(1)),'r--');
% semilogy(1:m,abs((evpos26(1:m,2)-ev_pos(2))./ev_pos(2)),'--','Color',[1 0.6 0]);
% semilogy(1:m,abs((evpos26(1:m,3)-ev_pos(3))./ev_pos(3)),'m--');
% legend('RelErr(\lambda_3^-)','RelErr(\lambda_2^-)', 'RelErr(\lambda_1^-)', 'RelErr(\lambda_1^+)', ...
%         'RelErr(\lambda_2^+)','RelErr(\lambda_3^+)', 'Location', 'NorthEast');
% %m1 = text(20, 1e-0, 'with preconditioning');
% %set(m1, 'EdgeColor', [0 0 0]);
% xlabel('iteration');
% title('relative error of eigenvalues');
% print('-depsc2', 'output/fig3.eps')
