 %% TEST 3  2000 vs 1000 %%%%%%%%%%%%%%%%
 
 load output2/outputSpring2000.mat;
 
  %%  test_spring

n=2000; n_pos=3;n_neg=3;k=n_pos+n_neg;
M=speye(n);
e = ones(n,1);
C = spdiags([-10*e 30*e -10*e], -1:1, n, n);
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
% definiteness interval is around ( -9.4818, -0.5278)

%% exact evs:  
 f_neg=zeros(1,n);f_pos=zeros(1,n);
    for k=1:n,
        c=cos(k*pi/(n+1));
        f([2*k-1 2*k])=roots([1, 30-20*c, 15-10*c]);
        f([2*k-1 2*k])=sort(f([2*k-1 2*k]));
        f_neg(n-k+1)=min(f([2*k-1 2*k]));
        f_pos(k)=max(f([2*k-1 2*k]));
    end
    ev_pos=f_pos(1:n_pos);               % n_pos wanted B-positive evs
    ev_neg=f_neg(n+1-n_neg:n);           % n_neg wanted B-negative evs
    figure(1)
    subplot(3,1,1)
    plot(real(f),imag(f),'bo')
    title('eigenvalues');
    axis([-50 0 -1 1])
    hold all
    subplot(3,1,2)
    plot(f_neg,'kx')
    title('B-negative eigenvalues');
    hold on
    subplot(3,1,3)
    plot(f_pos,'rx')
    title('B-positive eigenvalues');
    hold on
%%%%%%%%%%Xini%%%%%%%%%%%

m=size(evneg3,1);
br=100;
figure(6);                                         % relative residual norm 
semilogy(1:br:m,resneg3(1:br:m,1), 'bo');                   % for \lambda_3^-
hold on
semilogy(11:br:m,resneg3(11:br:m,2), '>','Color',[0 0.7 0]); %for \lambda_2^-
semilogy(21:br:m,resneg3(21:br:m,3), 'kx');                 %for \lambda_1^-
semilogy(1:br:m,respos3(1:br:m,1), 'r^');                  %for \lambda_1^+
semilogy(11:br:m,respos3(11:br:m,2), '*','Color',[1 0.6 0]); %for \lambda_2^+
semilogy(21:br:m,respos3(21:br:m,3), 'md');                   %for \lambda_3^+
semilogy(resneg3(1:m,1), 'b-');
semilogy(resneg3(1:m,2), '-','Color',[0 0.7 0]);
semilogy(resneg3(1:m,3), 'k-');
semilogy(respos3(1:m,1), 'r-');
semilogy(respos3(1:m,2), '-','Color',[1 0.6 0]);
semilogy(respos3(1:m,3), 'm-');
legend('Res(\lambda_3^-)','Res(\lambda_2^-)', 'Res(\lambda_1^-)', 'Res(\lambda_1^+)', ...
        'Res(\lambda_2^+)','Res(\lambda_3^+)', 'Location', 'NorthEast');
xlabel('iteration');
title('relative residual norm');
hold on


figure(7);                                              %  relative error
semilogy(1:br:m,abs((evneg3(1:br:m,1)-ev_neg(1))./ev_neg(1)),'bo');
hold on
semilogy(11:br:m,abs((evneg3(11:br:m,2)-ev_neg(2))./ev_neg(2)),'>','Color',[0 0.7 0]);
semilogy(21:br:m,abs((evneg3(21:br:m,3)-ev_neg(3))./ev_neg(3)),'kx');
semilogy(1:br:m,abs((evpos3(1:br:m,1)-ev_pos(1))./ev_pos(1)),'r^');
semilogy(11:br:m,abs((evpos3(11:br:m,2)-ev_pos(2))./ev_pos(2)),'*','Color',[1 0.6 0]);
semilogy(21:br:m,abs((evpos3(21:br:m,3)-ev_pos(3))./ev_pos(3)),'md');
semilogy(1:m,abs((evneg3(1:m,1)-ev_neg(1))./ev_neg(1)),'b-');
semilogy(1:m,abs((evneg3(1:m,2)-ev_neg(2))./ev_neg(2)),'-','Color',[0 0.7 0]);
semilogy(1:m,abs((evneg3(1:m,3)-ev_neg(3))./ev_neg(3)),'k-');
semilogy(1:m,abs((evpos3(1:m,1)-ev_pos(1))./ev_pos(1)),'r-');
semilogy(1:m,abs((evpos3(1:m,2)-ev_pos(2))./ev_pos(2)),'-','Color',[1 0.6 0]);
semilogy(1:m,abs((evpos3(1:m,3)-ev_pos(3))./ev_pos(3)),'m-');
legend('RelErr(\lambda_3^-)','RelErr(\lambda_2^-)', 'RelErr(\lambda_1^-)', 'RelErr(\lambda_1^+)', ...
        'RelErr(\lambda_2^+)','RelErr(\lambda_3^+)', 'Location', 'NorthEast');
%m1 = text(20, 1e-0, 'with preconditioning');
%set(m1, 'EdgeColor', [0 0 0]);
xlabel('iteration');
title('relative error of eigenvalues');


%%%%%%%%%%%%
 %% TEST 3 %%%%%%%%%%%%%%%%

 load output2/outputSpring1000.mat;
   %%  test_spring

n=1000; n_pos=3;n_neg=3;k=n_pos+n_neg;
M=speye(n);
e = ones(n,1);
C = spdiags([-10*e 30*e -10*e], -1:1, n, n);
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
% definiteness interval is around ( -9.4818, -0.5278)

%% exact evs:  
 f_neg=zeros(1,n);f_pos=zeros(1,n);
    for k=1:n,
        c=cos(k*pi/(n+1));
        f([2*k-1 2*k])=roots([1, 30-20*c, 15-10*c]);
        f([2*k-1 2*k])=sort(f([2*k-1 2*k]));
        f_neg(n-k+1)=min(f([2*k-1 2*k]));
        f_pos(k)=max(f([2*k-1 2*k]));
    end
    ev_pos=f_pos(1:n_pos);               % n_pos wanted B-positive evs
    ev_neg=f_neg(n+1-n_neg:n);           % n_neg wanted B-negative evs
    figure(1)
    subplot(3,1,1)
    plot(real(f),imag(f),'cx')
    axis([-50 0 -1 1])
    hold all
    subplot(3,1,2)
    plot(f_neg,'x','Color',[0 0.7 0])
    hold on
    subplot(3,1,3)
    plot(f_pos,'mx')
    print('-depsc2', 'output2/springEV.eps')
    print('-depsc2', 'output2/springEV.fig')
%%%%%%%%%%Xini%%%%%%%%%%%

m=size(evneg3,1);
br=100;
figure(6);                                         % relative residual norm 
semilogy(1:br:m,resneg3(1:br:m,1), 'bo');                   % for \lambda_3^-
hold on
semilogy(11:br:m,resneg3(11:br:m,2), '>','Color',[0 0.7 0]); %for \lambda_2^-
semilogy(21:br:m,resneg3(21:br:m,3), 'kx');                 %for \lambda_1^-
semilogy(1:br:m,respos3(1:br:m,1), 'r^');                  %for \lambda_1^+
semilogy(11:br:m,respos3(11:br:m,2), '*','Color',[1 0.6 0]); %for \lambda_2^+
semilogy(21:br:m,respos3(21:br:m,3), 'md');                   %for \lambda_3^+
semilogy(resneg3(1:m,1), 'b-.');
semilogy(resneg3(1:m,2), '-.','Color',[0 0.7 0]);
semilogy(resneg3(1:m,3), 'k-.');
semilogy(respos3(1:m,1), 'r-.');
semilogy(respos3(1:m,2), '-.','Color',[1 0.6 0]);
semilogy(respos3(1:m,3), 'm-.');
legend('Res(\lambda_3^-)','Res(\lambda_2^-)', 'Res(\lambda_1^-)', 'Res(\lambda_1^+)', ...
        'Res(\lambda_2^+)','Res(\lambda_3^+)', 'Location', 'NorthEast');
xlabel('iteration');
title('relative residual norm: \beta_1= -9, \beta_2= -0.55');
hold on
print('-depsc2', 'output2/spring3_relres.eps')
print('-depsc2', 'output2/sprig3_relres.fig')

figure(7);                                              %  relative error
semilogy(1:br:m,abs((evneg3(1:br:m,1)-ev_neg(1))./ev_neg(1)),'bo');
hold on
semilogy(11:br:m,abs((evneg3(11:br:m,2)-ev_neg(2))./ev_neg(2)),'>','Color',[0 0.7 0]);
semilogy(21:br:m,abs((evneg3(21:br:m,3)-ev_neg(3))./ev_neg(3)),'kx');
semilogy(1:br:m,abs((evpos3(1:br:m,1)-ev_pos(1))./ev_pos(1)),'r^');
semilogy(11:br:m,abs((evpos3(11:br:m,2)-ev_pos(2))./ev_pos(2)),'*','Color',[1 0.6 0]);
semilogy(21:br:m,abs((evpos3(21:br:m,3)-ev_pos(3))./ev_pos(3)),'md');
semilogy(1:m,abs((evneg3(1:m,1)-ev_neg(1))./ev_neg(1)),'b-.');
semilogy(1:m,abs((evneg3(1:m,2)-ev_neg(2))./ev_neg(2)),'-.','Color',[0 0.7 0]);
semilogy(1:m,abs((evneg3(1:m,3)-ev_neg(3))./ev_neg(3)),'k-.');
semilogy(1:m,abs((evpos3(1:m,1)-ev_pos(1))./ev_pos(1)),'r-.');
semilogy(1:m,abs((evpos3(1:m,2)-ev_pos(2))./ev_pos(2)),'-.','Color',[1 0.6 0]);
semilogy(1:m,abs((evpos3(1:m,3)-ev_pos(3))./ev_pos(3)),'m-.');
legend('RelErr(\lambda_3^-)','RelErr(\lambda_2^-)', 'RelErr(\lambda_1^-)', 'RelErr(\lambda_1^+)', ...
        'RelErr(\lambda_2^+)','RelErr(\lambda_3^+)', 'Location', 'NorthEast');
%m1 = text(20, 1e-0, 'with preconditioning');
%set(m1, 'EdgeColor', [0 0 0]);
xlabel('iteration');
title('relative error of eigenvalues: \beta_1= -9, \beta_2= -0.55');
print('-depsc2', 'output2/spring3_relerr.eps')
print('-depsc2', 'output2/spring3_relerr.fig')



% %%%%% Xini3 %%%%%%%%%%%
% m=size(evneg33,1);
% br=100;
% figure(6);                                         % relative residual norm 
% semilogy(1:br:m,resneg33(1:br:m,1), 'bo');                   % for \lambda_3^-
% hold on
% semilogy(11:br:m,resneg33(11:br:m,2), '>','Color',[0 0.7 0]); %for \lambda_2^-
% semilogy(21:br:m,resneg33(21:br:m,3), 'kx');                 %for \lambda_1^-
% semilogy(1:br:m,respos33(1:br:m,1), 'r^');                  %for \lambda_1^+
% semilogy(11:br:m,respos33(11:br:m,2), '*','Color',[1 0.6 0]); %for \lambda_2^+
% semilogy(21:br:m,respos33(21:br:m,3), 'md');                   %for \lambda_3^+
% semilogy(resneg33(1:m,1), 'b-.');
% semilogy(resneg33(1:m,2), '-.','Color',[0 0.7 0]);
% semilogy(resneg33(1:m,3), 'k-.');
% semilogy(respos33(1:m,1), 'r-.');
% semilogy(respos33(1:m,2), '-.','Color',[1 0.6 0]);
% semilogy(respos33(1:m,3), 'm-.');
% legend('Res(\lambda_3^-)','Res(\lambda_2^-)', 'Res(\lambda_1^-)', 'Res(\lambda_1^+)', ...
%         'Res(\lambda_2^+)','Res(\lambda_3^+)', 'Location', 'NorthEast');
% xlabel('iteration');
% title('relative residual norm');
% hold on
% print('-depsc2', 'output/fig2.eps')
% 
% figure(7);                                              %  relative error
% semilogy(1:br:m,abs((evneg33(1:br:m,1)-ev_neg(1))./ev_neg(1)),'bo');
% hold on
% semilogy(11:br:m,abs((evneg33(11:br:m,2)-ev_neg(2))./ev_neg(2)),'>','Color',[0 0.7 0]);
% semilogy(21:br:m,abs((evneg33(21:br:m,3)-ev_neg(3))./ev_neg(3)),'kx');
% semilogy(1:br:m,abs((evpos33(1:br:m,1)-ev_pos(1))./ev_pos(1)),'r^');
% semilogy(11:br:m,abs((evpos33(11:br:m,2)-ev_pos(2))./ev_pos(2)),'*','Color',[1 0.6 0]);
% semilogy(21:br:m,abs((evpos33(21:br:m,3)-ev_pos(3))./ev_pos(3)),'md');
% semilogy(1:m,abs((evneg33(1:m,1)-ev_neg(1))./ev_neg(1)),'b-.');
% semilogy(1:m,abs((evneg33(1:m,2)-ev_neg(2))./ev_neg(2)),'-.','Color',[0 0.7 0]);
% semilogy(1:m,abs((evneg33(1:m,3)-ev_neg(3))./ev_neg(3)),'k-.');
% semilogy(1:m,abs((evpos33(1:m,1)-ev_pos(1))./ev_pos(1)),'r-.');
% semilogy(1:m,abs((evpos33(1:m,2)-ev_pos(2))./ev_pos(2)),'-.','Color',[1 0.6 0]);
% semilogy(1:m,abs((evpos33(1:m,3)-ev_pos(3))./ev_pos(3)),'m-.');
% legend('RelErr(\lambda_3^-)','RelErr(\lambda_2^-)', 'RelErr(\lambda_1^-)', 'RelErr(\lambda_1^+)', ...
%         'RelErr(\lambda_2^+)','RelErr(\lambda_3^+)', 'Location', 'NorthEast');
% %m1 = text(20, 1e-0, 'with preconditioning');
% %set(m1, 'EdgeColor', [0 0 0]);
% xlabel('iteration');
% title('relative error of eigenvalues');
% print('-depsc2', 'output/fig3.eps')
% 
% %%%%% Xini6 %%%%%%%%%%%
% m=size(evneg36,1);
% br=100;
% figure(6);                                         % relative residual norm 
% semilogy(1:br:m,resneg36(1:br:m,1), 'bo');                   % for \lambda_3^-
% hold on
% semilogy(11:br:m,resneg36(11:br:m,2), '>','Color',[0 0.7 0]); %for \lambda_2^-
% semilogy(21:br:m,resneg36(21:br:m,3), 'kx');                 %for \lambda_1^-
% semilogy(1:br:m,respos36(1:br:m,1), 'r^');                  %for \lambda_1^+
% semilogy(11:br:m,respos36(11:br:m,2), '*','Color',[1 0.6 0]); %for \lambda_2^+
% semilogy(21:br:m,respos36(21:br:m,3), 'md');                   %for \lambda_3^+
% semilogy(resneg36(1:m,1), 'b--');
% semilogy(resneg36(1:m,2), '--','Color',[0 0.7 0]);
% semilogy(resneg36(1:m,3), 'k--');
% semilogy(respos36(1:m,1), 'r--');
% semilogy(respos36(1:m,2), '--','Color',[1 0.6 0]);
% semilogy(respos36(1:m,3), 'm--');
% legend('Res(\lambda_3^-)','Res(\lambda_2^-)', 'Res(\lambda_1^-)', 'Res(\lambda_1^+)', ...
%         'Res(\lambda_2^+)','Res(\lambda_3^+)', 'Location', 'NorthEast');
% xlabel('iteration');
% title('relative residual norm');
% hold on
% print('-depsc2', 'output/fig2.eps')
% 
% figure(7);                                              %  relative error
% semilogy(1:br:m,abs((evneg36(1:br:m,1)-ev_neg(1))./ev_neg(1)),'bo');
% hold on
% semilogy(11:br:m,abs((evneg36(11:br:m,2)-ev_neg(2))./ev_neg(2)),'>','Color',[0 0.7 0]);
% semilogy(21:br:m,abs((evneg36(21:br:m,3)-ev_neg(3))./ev_neg(3)),'kx');
% semilogy(1:br:m,abs((evpos36(1:br:m,1)-ev_pos(1))./ev_pos(1)),'r^');
% semilogy(11:br:m,abs((evpos36(11:br:m,2)-ev_pos(2))./ev_pos(2)),'*','Color',[1 0.6 0]);
% semilogy(21:br:m,abs((evpos36(21:br:m,3)-ev_pos(3))./ev_pos(3)),'md');
% semilogy(1:m,abs((evneg36(1:m,1)-ev_neg(1))./ev_neg(1)),'b--');
% semilogy(1:m,abs((evneg36(1:m,2)-ev_neg(2))./ev_neg(2)),'--','Color',[0 0.7 0]);
% semilogy(1:m,abs((evneg36(1:m,3)-ev_neg(3))./ev_neg(3)),'k--');
% semilogy(1:m,abs((evpos36(1:m,1)-ev_pos(1))./ev_pos(1)),'r--');
% semilogy(1:m,abs((evpos36(1:m,2)-ev_pos(2))./ev_pos(2)),'--','Color',[1 0.6 0]);
% semilogy(1:m,abs((evpos36(1:m,3)-ev_pos(3))./ev_pos(3)),'m--');
% legend('RelErr(\lambda_3^-)','RelErr(\lambda_2^-)', 'RelErr(\lambda_1^-)', 'RelErr(\lambda_1^+)', ...
%         'RelErr(\lambda_2^+)','RelErr(\lambda_3^+)', 'Location', 'NorthEast');
% %m1 = text(20, 1e-0, 'with preconditioning');
% %set(m1, 'EdgeColor', [0 0 0]);
% xlabel('iteration');
% title('relative error of eigenvalues');
% print('-depsc2', 'output/fig3.eps')
