 %%  paper-test2
% EXACT INVERSE
clear
n=1000;
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3; % number of extracted eigenpairs (k_\pm >= l_\pm)
tol=1e-8;maxiter=500;
M=speye(n);
e = ones(n,1);
K = (n+1)^2*full(spdiags([-e 2*e -e], -1:1, n, n));
K=sparse(K);
D=2*K;
%K = spdiags([-5*e 15*e -5*e], -1:1, n, n); D = spdiags([-10*e 30*e -10*e], -1:1, n, n); % definiteness interval is around ( -9.4818, -0.5278)
% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M D];%2n x 2n pencil
% definiteness interval is around ( -19.225842, -0.513351)
%% initial guess
%br_pos=3;br_neg=3; % more columns in initial guess
I=speye(2*n);
II=speye(n);
Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
%Xini=full([I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
%% 0. TEST:  mu0 
mu0=-9;
T0=A-mu0*B;

fprintf('\n Test0: Algorithm 1 (one preconditioner) with T=inv(A-%f*B). \n',mu0);
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3;
Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
tic
[D0, X, iter0,h0] = indef_lobpcg(A, B, T0, [], Xini, k_pos, k_neg, tol, maxiter);
t0=toc;
save('output/outputQuadraticEXACT1000.mat','h0');
save('output/outputQuadraticEXACT1000.mat','D0','-append');
save('output/outputQuadraticEXACT1000.mat','iter0','-append');
save('output/outputQuadraticEXACT1000.mat','t0','-append');
%% 1. TEST: mu1p and mu1n
mu1p=-1.5;
mu1n=-18;
T1p=A-mu1p*B;
T1n=A-mu1n*B;

fprintf('\n Test1: Algorithm 2 (two preconditioners) with T_+=inv(A-(%f) *B), T_-=inv(A-(%f) *B) and Xini \n',mu1p,mu1n);
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3;
Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
tic
[D1, X, iter1,h1] = indef_lobpcg(A, B, T1p, T1n, Xini, k_pos,k_neg, tol, maxiter);
t1=toc;
save('output/outputQuadraticEXACT1000.mat','h1','append');
save('output/outputQuadraticEXACT1000.mat','D1','-append');
save('output/outputQuadraticEXACT1000.mat','iter1','-append');
save('output/outputQuadraticEXACT1000.mat','t1','-append');

fprintf('\n Test1: Algorithm 2 (two preconditioners) with T_+=inv(A-(%f) *B), T_-=inv(A-(%f) *B). \n',mu1p,mu1n);
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=4;k_neg=4;
Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
tic
[D14, X, iter14,h14] = indef_lobpcg(A, B, T1p, T1n, Xini, k_pos,k_neg, tol, maxiter);
t14=toc;
save('output/outputQuadraticEXACT1000.mat','h14');
save('output/outputQuadraticEXACT1000.mat','D14','-append');
save('output/outputQuadraticEXACT1000.mat','iter14','-append');
save('output/outputQuadraticEXACT1000.mat','t14','-append');
%% 2. TEST: mu2p and mu2n
mu2p=-0.51;
mu2n=-19.2;
T2p=A-mu2p*B;
T2n=A-mu2n*B;

l_pos=3;l_neg=3; % number of wanted eigenpairs
 k_pos=3;k_neg=3;
 Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
fprintf('Test2: Algorithm 2 (two preconditioners) with T_+=inv(A-%f*B), T_-=inv(A-%f*B) and Xini \n',mu2p,mu2n);
tic
[D2, X, iter2,h2] = indef_lobpcg(A, B, T2p, T2n, Xini,k_pos, k_neg, tol, maxiter);
t2=toc;
save('output/outputQuadraticEXACT1000.mat','h2','append');
save('output/outputQuadraticEXACT1000.mat','D2','-append');
save('output/outputQuadraticEXACT1000.mat','iter2','-append');
save('output/outputQuadraticEXACT1000.mat','t2','-append');

l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=4;k_neg=4;
 Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
fprintf('Test2: Algorithm 2 (two preconditioners) with T_+=inv(A-%f*B), T_-=inv(A-%f*B) and Xini \n',mu2p,mu2n);
tic
[D24, X, iter24,h24] = indef_lobpcg(A, B, T2p, T2n, Xini,k_pos, k_neg, tol, maxiter);
t24=toc;
save('output/outputQuadraticEXACT1000.mat','h24','append');
save('output/outputQuadraticEXACT1000.mat','D24','-append');
save('output/outputQuadraticEXACT1000.mat','iter24','-append');
save('output/outputQuadraticEXACT1000.mat','t24','-append');