 %%  paper-test2
% HSL MI20 AMG PRECONDITIONER
clear
addpath('/srv/share/malc1/data/mshao/lib/hsl_mi20-1.5.1/matlab/');
javaaddpath('/srv/share/malc1/data/mshao/lib/hsl_mi20-1.5.1/matlab/');
n=1000;
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3; % number of extracted eigenpairs (k_\pm >= l_\pm)
tol=1e-8;maxiter=300;

M=speye(n);
e = ones(n,1);
K = (n+1)^2*full(spdiags([-e 2*e -e], -1:1, n, n));
K=sparse(K);
D=2*K;
%K = spdiags([-5*e 15*e -5*e], -1:1, n, n); D = spdiags([-10*e 30*e -10*e], -1:1, n, n); % definiteness interval is around ( -9.4818, -0.5278)
% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M D];%2n x 2n pencil
% definiteness interval is around ( -19.225842, -0.513351)
%% initial guess

I=speye(2*n);
II=speye(n);
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
%Xini=[I(:,n+1:(n+k_neg)) I(:,1:k_pos)];

%% 0. TEST:  mu0 (Alg.1)
mu0=-9;
T0=A-mu0*B;

hsl_mi20_startup
control0 = hsl_mi20_control;
control0.c_fail = 2;
inform0 = hsl_mi20_setup0(T0,control0);

fprintf('\n Test0: Algorithm 1 (one preconditioner) with AMG T = inv(A-(%f)*B).\n',mu0);
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3;
Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
tic
[D0, X, iter0,h0] = indef_lobpcg(A, B, 'hsl_mi20_precondition0', [], Xini, k_pos, k_neg, tol, maxiter);
t0=toc;

hsl_mi20_finalize0;
%% 1. TEST: mu1p and mu1n
mu1p=-1.5;
mu1n=-18;
T1p=A-mu1p*B;
T1n=A-mu1n*B;

hsl_mi20_startup
control1p = hsl_mi20_control;
control1p.c_fail = 2;
inform1p = hsl_mi20_setup1p(T1p,control1p);
control1n = hsl_mi20_control;
control1n.c_fail = 2;
inform1n = hsl_mi20_setup1n(T1n,control1n);

fprintf('\n Test1: Algorithm 2 (two preconditioners) with T_+ \appr inv(A-%f*B), T_-=inv(A-%f*B).\n',mu1p,mu1n);
tic
[D1, X, iter1,h1] = indef_lobpcg(A, B, T1p, T1n, Xini, k_pos, k_neg, tol, maxiter);
t1=toc;
hsl_mi20_finalize1p;
hsl_mi20_finalize1n;
%% 2. TEST: mu2p and mu2n
mu2p=-0.51;
mu2n=-19.2;
T2p=A-mu2p*B;
T2n=A-mu2n*B;

hsl_mi20_startup
control2p = hsl_mi20_control;
control2p.c_fail = 2;
inform2p = hsl_mi20_setup2p(T2p,control2p);
control2n = hsl_mi20_control;
control2n.c_fail = 2;
inform2n = hsl_mi20_setup2n(T2n,control2n);

l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3;
Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ \appr inv(A-%f*B), T_-=inv(A-%f*B)\n',mu2p,mu2n);
tic
[D2, X, iter2,h2] = indef_lobpcg(A, B, T2p, T2n, Xini, k_pos, k_neg, tol, maxiter);
t2=toc;

hsl_mi20_finalize2p;
hsl_mi20_finalize2n;